/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_RELFILTRAS                                               */
/* Tabela : RELFILTRAS                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_RELFILTRAS'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_RELFILTRAS
GO

CREATE TRIGGER DTULTATU_RELFILTRAS
ON RELFILTRAS
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'RELFILTRAS', CDFILIAL, 'CDFILIAL='+ CDFILIAL+ ';'+
                                               'NRINSJURTRAN='+ NRINSJURTRAN+ ';'+
                                               'IDTPIJURTRAN='+ IDTPIJURTRAN+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE RELFILTRAS
      SET DTULTATUFITR = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(RELFILTRAS.IDTPIJURTRAN,0) = ISNULL(INSERTED.IDTPIJURTRAN,0)) AND
            (ISNULL(RELFILTRAS.NRINSJURTRAN,0) = ISNULL(INSERTED.NRINSJURTRAN,0)) AND
            (ISNULL(RELFILTRAS.IDTRANSPRINC,0) = ISNULL(INSERTED.IDTRANSPRINC,0)) AND
            (ISNULL(RELFILTRAS.CDFILIAL,0)     = ISNULL(INSERTED.CDFILIAL,0));
   END;
END;
GO

